package dags;

import util.listreader.*;
import util.logkeeper.*;
import util.arrapp.Arrapp;
import java.io.*;

public class BatchDager{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static FileOutputStream out, outD, dataOut;
  static File outfile, outfileD;
  static String[] dfds;
  static String[] arities;
  static String[] data;
  static Dager dager;
  static int[][] dag;
  static DagGrapher dg;

// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
    if (args.length!=1) {
      System.out.println("Usage: java BatchDager joblistfile");
    } else {
      int arglen = args[0].length();
      LogKeeper.setup(args[0]+".log");
      ListReader LR = new ListReader("util/dags/DAGdata");
      LR.initialize();
      data = LR.readAll();
      try {
        outfile = new File(args[0]+".dag");
        out = new FileOutputStream(outfile);
        //String Dname = "Depth" + args[0].substring(0,arglen-2) + ".tex";
        String Dname = args[0].substring(0,arglen-2) + "depth.tex";
        outfileD = new File(Dname);
        outD = new FileOutputStream(outfileD);
        File dataOutFile = new File("util/dags/DAGdata");
        dataOut = new FileOutputStream(dataOutFile);
      } catch (IOException e) {
        LogKeeper.record("Could not create output file.");
      }
      LR = new ListReader(args[0]);
      LR.initialize();
      dfds = LR.readAll();
      parseDfds();
      String L;
      String chno = args[0].substring(arglen-3,arglen-2);
      String M = "\\bigskip\n\\begin{center}\n\\begin{tabular}{l c c | l c c}\n" +
                 "{\\bf Suppes Chapter " + chno + "}  \\\\\n" +
                 "{\\bf Definiendum} & {\\bf Depth} & {\\bf Size} & " +
                 "{\\bf Definiendum} & {\\bf Depth} & {\\bf Size} \\\\ \\hline \n";
      try {
        outD.write(M.getBytes());
      } catch (IOException e) {
        LogKeeper.record("File access error at <BatchDager:50>");
      }
      String K;
      for (int i = 0; i < dfds.length; i++) {
        Dager.construct(dfds[i],arities[i]);
        dag = dager.sortMulti();
        dg = new DagGrapher(dag);
        L = "$(" + dfds[i] + ":" + arities[i] + ")$\n";
        L += dg.graphMulti();
        L += "\n\n";
        M = "$\\mathop{\\mathtt{"+dfds[i] + "}}$:" + arities[i] + " & ";
        M += Integer.toString(dag.length) + " & ";
        M += Integer.toString(Dager.dfds.length);
        M += (i%2==0?" & ":"\\\\\n");
        K = Integer.toString(dag.length)+":"+
            Integer.toString(Dager.dfds.length);
        data = Arrapp.append(data,K);
        try {
          out.write(L.getBytes());
          outD.write(M.getBytes());
        } catch (IOException e) {
          LogKeeper.record("Could not record dag for dfd: (" + dfds[i] + ":" +
                           arities[i] + ").");
        }
      }
      M = "\\end{tabular}\n\\end{center}\n";
      try {
        outD.write(M.getBytes());
      } catch (IOException e) {
        LogKeeper.record("File access error at <BatchDager:75>");
      }
      for (int i = 0; i < data.length; i++) {
        try {
          K = data[i]+"\n";
          dataOut.write(K.getBytes());
        } catch (IOException e) {e.printStackTrace();}
      }
    }
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  static void parseDfds() {
    //Diagnostic:
    if (dfds==null) {System.out.println("<BatchDager.java:65>dfds is null.");}
    //
    arities = new String[dfds.length];
    String L; int w;
    for (int i = 0; i < dfds.length; i++) {
      L = dfds[i]; w = -1;
      for (int j = 0; j < L.length(); j++) {
        if (L.substring(j,j+1).equals(":")) {
          w = j; break;
        }
      }
      if (w==-1) {
        System.out.println("Error: user did not supply arity for dfd: " + L + ".");
      }
      dfds[i] = L.substring(0,w);
      arities[i] = L.substring(w+1,L.length());
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 