package dags;

import org.w3c.dom.*;

public class Body{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public FormulaBuilder[] data;
  public String arity;
  public String type;
  public String dfd;
  
  private Document d;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Body() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public Element output(Document doc) {
    Element d = doc.createElement("definition");
    d.setAttribute("arity",arity);
    d.setAttribute("type",type);
    if (arity.equals("infix") && type.equals("function")) {
      d.setAttribute("precedence",data[1].auxData[0]);
    }
    Element e = doc.createElement("text");
    e.appendChild(doc.createTextNode(data[0].toString()));
    d.appendChild(e);
    e = doc.createElement("definiendum");
    e = suffixDoc(e,doc,data[1]);
    d.appendChild(e);
    e = doc.createElement("definiens");
    e = suffixDoc(e,doc,data[2]);
    d.appendChild(e);
    return d;
  }
  
  public String buildLaTeX() {
    String L = "\\noindent $";
    L += data[0].toStringWithWrap();
    L += "$";
    return L;
  }
  
  public Element suffixDoc(Element p, Document d, FormulaBuilder x) {
    NodeList n = x.d.getFirstChild().getChildNodes();
    Element e,f; String s;
    for (int i = 0; i < n.getLength(); i++) {
      e = (Element) n.item(i);
      s = e.getTagName();
      if (s.equals("text")) {
        f = (Element) d.createElement(s);
        String t = e.getFirstChild().getNodeValue();
        f.appendChild(d.createTextNode(t));
        p.appendChild(f);
      }
      if (s.equals("var")) {
        f = (Element) d.createElement(s);
        f.setAttribute("t",e.getAttribute("t"));
        f.setAttribute("n",e.getAttribute("n"));
        p.appendChild(f);
      }
      if (s.equals("def")) {
        f = (Element) d.createElement(s);
        String t = e.getFirstChild().getNodeValue();
        f.appendChild(d.createTextNode(t));
        p.appendChild(f);
      }
    }
    return p;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 