package expandDG;

import util.listreader.*;
import util.arrapp.Arrapp;
import lpt2dzfc.MathDefDictionary;
import org.w3c.dom.*;
import java.io.*;

public class BQuantDG{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static String[] dfds;
  static String[] arities;
  static String[][] data;
  static String[] leaves;
  static int[] leafArities;
  static MathDefDictionary mdd = new MathDefDictionary();
  static Node N;
  static NodeList dfn;
  static File outf;
  static FileOutputStream out;
  static final String LEAFFILE = "expandDG/leaves";
  
// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
    if (args.length!=1) {
      System.out.println("Usage: java BQuantDG joblistfile");
    } else {
      try {
        outf = new File(args[0].substring(0,args[0].length()-2)+"expdataQ.tex");
        out = new FileOutputStream(outf);
      } catch (IOException e) {
      }
      String chno = args[0].substring(args[0].length()-4,args[0].length()-2);
      ListReader LR = new ListReader(LEAFFILE);
      LR.initialize();
      leaves = LR.readAll();
      parseLeaves();
      QuantDG.leaves = leaves;
      QuantDG.leafArities = leafArities;
      LR = new ListReader(args[0]);
      LR.initialize();
      dfds = LR.readAll();
      data = new String[dfds.length][];
      for (int i = 0; i < dfds.length; i++) {
        data[i] = new String[3];
      }
      parseDfds();
      QuantDG qdg;
      int[] F;
      int D;
      String S;
      for (int k = 0; k < 3; k++) {
        QuantDG.mode = k;
        QuantDG.setList();
        QuantDG.init();
        for (int i = 0; i < dfds.length; i++) {
          N = mdd.lookUpDefiniens(dfds[i],arities[i]);
          dfn = N.getChildNodes();
          QuantDG.dfd = dfds[i]; QuantDG.arity = arities[i];
          QuantDG.dfn = dfn;
          try {
            QuantDG.preScan();
          } catch (Exception e) {
            e.printStackTrace();
          }
          qdg = new QuantDG();
          F = qdg.buildFunc();
          QuantDG.functions = Arrapp.append(QuantDG.functions,F);
          QuantDG.dfds = Arrapp.append(QuantDG.dfds,dfds[i]);
          String A = (arities[i].equals("infix")?"2":arities[i]);
          QuantDG.arities = Arrapp.append(QuantDG.arities,A);
          D = QuantDG.evalAtZeros(F);
          S = Integer.toString(D);
          if (D==Integer.MAX_VALUE) {S += "+";}
          data[i][k] = new String(S);
        }
        QuantDG.record();
      }
      try {
        S = "\\bigskip\n"+
            "\\begin{center}\n"+
            "\\begin{tabular}{l l l l}\n"+
            "{\\bf Munkres Chapter " + chno + "} \\\\\n"+
            "{\\bf Definiendum} & {\\bf 0} & {\\bf A} & {\\bf B}\\\\ \\hline\n";
        out.write(S.getBytes());
        for (int i = 0; i < dfds.length; i++) {
          S = "$\\mathop{\\mathtt{"+dfds[i]+"}}$:"+arities[i]+" & "+
              data[i][0]+" & "+
              data[i][1]+" & "+
              data[i][2]+"\\\\\n";
          out.write(S.getBytes());
        }
        S = "\\end{tabular}\n"+
            "\\end{center}\n";
        out.write(S.getBytes());
      } catch (IOException e) {
      }
    }
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  static void parseDfds() {
    //Diagnostic:
    if (dfds==null) {System.out.println("<BatchDager.java:65>dfds is null.");}
    //
    arities = new String[dfds.length];
    String L; int w;
    for (int i = 0; i < dfds.length; i++) {
      L = dfds[i]; w = -1;
      for (int j = 0; j < L.length(); j++) {
        if (L.substring(j,j+1).equals(":")) {
          w = j; break;
        }
      }
      if (w==-1) {
        System.out.println("Error: user did not supply arity for dfd: " + L + ".");
      }
      dfds[i] = L.substring(0,w);
      arities[i] = L.substring(w+1,L.length());
    }
  }
  
  static void parseLeaves() {
    if (leaves!=null) {
      leafArities = new int[leaves.length];
      String L; int w;
      for (int i = 0; i < leaves.length; i++) {
        L = leaves[i]; w = -1;
        for (int j = 0; j < L.length(); j++) {
          if (L.substring(j,j+1).equals(":")) {
            w = j; break;
          }
        }
        if (w==-1) {
          System.out.println("Error: user did not supply arity for leaf: " + L + ".");
        }
        leaves[i] = L.substring(0,w);
        leafArities[i] = Integer.parseInt(L.substring(w+1,L.length()));
      }
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 