package expandDG;

import java.io.*;
import util.arrapp.Arrapp;

public class SimpleQ {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  static FileInputStream in;
  static FileOutputStream out;
  static String[] defs = new String[0];
  static QbubbleMgr qbm;

  static boolean verbose = true;
  
  String[] depths, altdepths;
  
// ----------------------------------------------
// Vox
// ----------------------------------------------
  
  static void vox(int n) {vox("",n);}
  
  static void vox(String s, int n) {
    if (verbose) {
      switch(n) {
        case 0:
          for (int i = 0; i < defs.length; i++) {
            System.out.println(Integer.toString(i) + ": " + defs[i]);
          }
        break;
      }
    }
  }

// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
    if (args.length!=1) {
      System.out.println("usage: java expandDG/SimpleQ deffile");
    } else {
      try {
        File f = new File(args[0]);
        in = new FileInputStream(f);
        int k = args[0].length();
        f = new File(args[0].substring(0,k-4) + ".qdp");
        out = new FileOutputStream(f);
      } catch (IOException e) {
        e.printStackTrace();
      }
      readDefs(); String s;
      QbubbleMgr.alternating = true;
      for (int i = 1; i < defs.length; i++) {
        qbm = new QbubbleMgr();
        qbm.read(defs[i]);
        s = Integer.toString(qbm.qMax) + "\n";
        try {
          out.write(s.getBytes());
        } catch (IOException e) {}
      }
    }
  }

// ----------------------------------------------------------------------------
// Constructor
// ----------------------------------------------------------------------------

  public SimpleQ(String filename) {
    try {
      File f = new File("lptparse/lptfiles/"+filename+".lpt");
      in = new FileInputStream(f);
    } catch (IOException e) {e.printStackTrace();}
    readDefs();
    depths = new String[defs.length-1];
    altdepths = new String[defs.length-1];
    QbubbleMgr.alternating = false;
    for (int i = 1; i < defs.length; i++) {
      qbm = new QbubbleMgr(2);
      qbm.read(defs[i]);
      depths[i-1] = Integer.toString(qbm.qMax);
    }
    QbubbleMgr.alternating = true;
    for (int i = 1; i < defs.length; i++) {
      qbm = new QbubbleMgr(2);
      qbm.read(defs[i]);
      altdepths[i-1] = Integer.toString(qbm.qMax);
    }
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  static void readDefs() {
    int n = -1;
    byte[] a = new byte[1];
    byte[] b = new byte[9];
    String u,s;
    String d = "";
    try {
      n = (int) in.read();
    } catch (IOException e) {}
    while (n>=0) {
      a[0] = (byte) n;
      u = new String(a);
      if (u.equals("D")) {
        try {
          in.read(b);
        } catch (IOException e) {}
        s = new String(b);
        if (s.equals("EFINITION")) {
          defs = Arrapp.append(defs,d);
          d = "";
        } else {
          d += u+s;
        }
      } else {
        d += u;
      }
      try {
        n = (int) in.read();
      } catch(IOException e) {}
    }
    defs = Arrapp.append(defs,d);
    vox(0);
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 