package graphs;

import java.awt.Point;

public class Edge{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  KmapVertex tail, head;
  private int x1, y1, x2, y2;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Edge() {
  }
  
  public Edge(KmapVertex t, KmapVertex h) {
    tail = t; head = h;
  }
  
  public Edge(int x1, int y1, int x2, int y2) {
    this.x1 = x1; this.y1 = y1; this.x2 = x2; this.y2 = y2;  
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  Vertex getTailVertex() {return tail;}
  
  Vertex getHeadVertex() {return head;}
  
  void setCoords() {
    //Find centers:
    int a = tail.X+tail.getSize().width/2;
    int b = tail.Y-tail.getSize().height/2;
    int c = head.X+head.getSize().width/2;
    int d = head.Y-head.getSize().height/2;
    //Simple for now:
    x1 = a; y1 = b; x2 = c; y2 = d;
  }
  
  Point getTailPosition() {
    setCoords();
    return new Point(x1,y1);
  }
  
  Point getHeadPosition() {
    setCoords();
    return new Point(x2,y2);
  }
  
  void setTailVertex(KmapVertex v) {
    tail = v;
  }
  
  void setHeadVertex(KmapVertex v) {
    head = v;
  }
  
  void setTailPosition(int x, int y) {
    x1 = x; y1 = y;
  }
  
  void setHeadPosition(int x, int y) {
    x2 = x; y2 = y;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 