package lpt2dzfc;

public class Funcdef{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public FormulaBuilder[] simple = null;
  private FormulaBuilder[] conditions = null;
  private FormulaBuilder[][] units = null;
  public FormulaBuilder[] otherwise = null;
  public String prec = null;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Funcdef() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder[] output() {
    FormulaBuilder[] D = new FormulaBuilder[3];
    if (simple!=null) {
      //simple[1] should not be null, as a function def with a single clause
      //must not simply use the uparrow of nondefinition.
      //Align free variables:
      simple[1].prefixVars(simple[0]);
      //Definiens:
      D[2] = simple[1];
      //Definiendum:
      D[1] = simple[0];
      //Def:
      FormulaBuilder def = new FormulaBuilder();
      def.append(D[1]);
      def.addText(" \\simeq ");
      def.append(D[2]);
      D[0] = def;
    } else {
      //Align free variables:
      for (int i = 0; i < units.length; i++) {
        units[i][1].prefixVars(units[i][0]);
      }
      if (otherwise!=null && otherwise[1]!=null) {otherwise[1].prefixVars(otherwise[0]);}
      //Generate bound variable:
      FormulaBuilder g = new FormulaBuilder();
      for (int i = 0; i < conditions.length; i++) {
        g.append(conditions[i]);
        g.append(units[i][1]);
      }
      String z = g.fresh();
      //Definiens:
      D[2] = new FormulaBuilder();
      D[2].addText("(\\iota ");
      D[2].addVar(z);
      D[2].addText(")(");
      //Count conditions under which the function is defined:
      int defTimes = 0;
      for (int i = 0; i < conditions.length; i++) {
        if (units[i][1]!=null) {defTimes++;}
      }
      if (otherwise!=null) {defTimes++;}
      //Now parenthesize accordingly:
      if (defTimes < 2) {
        D[2].append(conditions[0]);
        D[2].addText(" \\wedge ");
        D[2].addVar(z);
        D[2].addText(" \\simeq ");
        D[2].append(units[0][1]);
      } else {
        for (int i = 0; i < conditions.length; i++) {
          if (units[i][1]!=null) {
            D[2].addText("(");
            D[2].append(conditions[i]);
            D[2].addText(" \\wedge ");
            D[2].addVar(z);
            D[2].addText(" \\simeq ");
            D[2].append(units[i][1]);
            D[2].addText(")");
          }
          if (i!=conditions.length-1) {D[2].addText(" \\vee ");}
        }
        if (otherwise!=null && otherwise[1]!=null) {
          D[2].addText(" \\vee (\\neg (");
          for (int i = 0; i < conditions.length; i++) {
            D[2].append(conditions[i]);
            if (i !=conditions.length-1) {D[2].addText(" \\vee ");}
          }
          D[2].addText(") \\wedge ");
          D[2].addVar(z);
          D[2].addText(" \\simeq ");
          D[2].append(otherwise[1]);
          D[2].addText(")");
        }
      }
      D[2].addText(")");
      D[2].bind(z);
      //Definiendum:
      D[1] = units[0][0];
      //Def:
      FormulaBuilder def = new FormulaBuilder();
      def.append(D[1]);
      def.addText(" \\simeq ");
      def.append(D[2]);
      D[0] = def;
    }
    //Set precedence number, if applicable:
    if (prec!=null) {
      D[1].auxData = new String[1];
      D[1].auxData[0] = prec;
    }
    return D;
  }
  
  public void addCond(FormulaBuilder c) {
    if (conditions==null) {
      conditions = new FormulaBuilder[1];
      conditions[0] = c;
    } else {
      FormulaBuilder[] a = new FormulaBuilder[conditions.length+1];
      System.arraycopy(conditions,0,a,0,conditions.length);
      a[conditions.length] = c;
      conditions = a;
    }
  }
  
  public void addUnit(FormulaBuilder[] r) {
    if (units==null) {
      units = new FormulaBuilder[1][];
      units[0] = r;
    } else {
      FormulaBuilder[][] a = new FormulaBuilder[units.length+1][];
      System.arraycopy(units,0,a,0,units.length);
      a[units.length] = r;
      units = a;
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 