package lpt2dzfc;

public class Infixfunc{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public String defined = null;
  public FormulaBuilder term = null;
  
  public MathDefDictionary mdd = new MathDefDictionary();
  
  private String precedence = null;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Infixfunc() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output(FormulaBuilder s, FormulaBuilder t) {
    FormulaBuilder f = new FormulaBuilder();
    FormulaBuilder[] a = new FormulaBuilder[2];
    a[0] = s; a[1] = t;
    if (term!=null) {
      Term mdt = new Term();
      f = mdt.evaluate(term,a);
    }
    if (defined!=null) {
      DefinedConcept mddc = new DefinedConcept("function");
      mddc.concept = defined;
      mddc.args = a;
      mddc.arity = "infix";
      mddc.dfd(false);
      mddc.mdd = this.mdd;
      f = mddc.output();
    }
    return f;
  }
  
  public String getPrecNum() {
    if (precedence==null) {
      if (defined!=null) {
        precedence = mdd.lookUpInfixPrecedence(defined);
      } else {
        precedence = "infinity";
      }
    }
    return precedence;
  }
  
  public int compareTo(Infixfunc that) {
    int c;
    String a = this.getPrecNum();
    String b = that.getPrecNum();
    if (a.equals("infinity")) {
      if (b.equals("infinity")) {c = 0;}
      else {c = 1;}
    } else {
      if (b.equals("infinity")) {c = -1;}
      else {
        if (a.substring(0,1).equals("-")) {
          if (!b.substring(0,1).equals("-")) {c = -1;}
          else {
            String A = a.substring(1,a.length());
            String B = b.substring(1,b.length());
            c = B.compareTo(A);
          }
        } else {
          if (b.substring(0,1).equals("-")) {c = 1;}
          else {
            String A = a.substring(1,a.length());
            String B = b.substring(1,b.length());
            c = A.compareTo(B);
          }
        }
      }
    }
    return c;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 