package lpt2dzfc;

public class Lambda{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public String[] vars;
  public Infixrel onecondRel = null;
  public FormulaBuilder[] onecondTerms = null;
  public FormulaBuilder twocond = null;
  public FormulaBuilder term;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Lambda() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output() {
    //Generate any infix conditions:
    FormulaBuilder ics = null;
    if (onecondRel!=null) {
      ics = new FormulaBuilder();
      FormulaBuilder wrapper;
      for (int i = 0; i < vars.length; i++) {
        for (int j = 0; j < onecondTerms.length; j++) {
          wrapper = new FormulaBuilder(); wrapper.addVar(vars[i]);
          ics.append(onecondRel.output(wrapper,onecondTerms[j]));
          if (i < vars.length - 1 || j < onecondTerms.length - 1) {
            ics.addText(" \\wedge ");
          }
        }
      }
    }
    //Generate bound variables:
    FormulaBuilder g = new FormulaBuilder();
    for (int i = 0; i < vars.length; i++) {g.addVar(vars[i]);}
    if (twocond!=null) {g.append(twocond);}
    if (ics!=null) {g.append(ics);}
    g.append(term);
    String y = g.fresh();
    g.addVar(y);
      //Generate the tuple:
    Tupler mdtup = new Tupler();
    FormulaBuilder[] a = new FormulaBuilder[vars.length+1];
    for (int i = 0; i < vars.length; i++) {
      a[i] = new FormulaBuilder(); a[i].addVar(vars[i]);
    }
    a[vars.length] = new FormulaBuilder(); a[vars.length].addVar(y);
    FormulaBuilder tuple = mdtup.tuple(a);
    g.append(tuple);
      //Now the last two bound variables:
    String z = g.fresh();
    g.addVar(z);
    String f = g.fresh();
    //Build formula:
    FormulaBuilder out = new FormulaBuilder();
    out.addText("(\\iota ");
    out.addVar(f);
    out.addText(")(\\forall ");
    out.addVar(z);
    out.addText(")(");
    out.addVar(z);
    out.addText(" \\in ");
    out.addVar(f);
    out.addText(" \\rightleftarrow (\\exists ");
    for (int i = 0; i < vars.length; i++) {
      out.addVar(vars[i]);
      out.addText(", ");
    }
    out.addVar(y);
    out.addText(")(");
    out.addVar(z);
    out.addText(" = ");
    out.append(tuple);
    out.addText(" \\wedge ");
    out.addVar(y);
    out.addText(" = ");
    out.append(term);
    if (ics!=null) {
      out.addText(" \\wedge ");
      out.append(ics);
    }
    if (twocond!=null) {
      out.addText(" \\wedge ");
      out.append(twocond);
    }
    out.addText("))");
    return out;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 