/* Generated By:JavaCC: Do not edit this line. Lpt2dzfc.java */
package lpt2dzfc;

import util.logkeeper.LogKeeper;
import org.w3c.dom.*;
import java.io.*;

public class Lpt2dzfc implements Lpt2dzfcConstants {
  static private Lpt2dzfc parser;
  static private FileInputStream inputFile;
  static private FileOutputStream LaTeXoutputFile, dFile, eFile;
  static private MathDefDictionary mdd = new MathDefDictionary();
  static private String eFileOutput;

  static private String input = "";

  static private XNode root = new XNode("root","");

  public static void main(String args[]) throws ParseException {
    if (args.length != 3) {
      System.out.println(
            "Usage: java lpt2dzfc/Lpt2dzfc (-t|-p|-s|-o) inputfile outputName\n"
          + "\n"
          + "-t to simply construct the tree\n"
          + "-p to simply print definitions to the screen\n"
          + "-s to record definitions, skipping duplicates\n"
          + "-o to record definitions, overwriting duplicates\n"
      );
      return;
    }

    if (args[0].equals("-o")) { mdd.overwrite = true; }

    try {
      LaTeXoutputFile = new FileOutputStream(new File("tex/"+args[2]+".tex"));
    } catch (IOException e) {
      System.out.println("LaTeX output file could not be created.");
    }
    try {
      dFile = new FileOutputStream(new File("dFiles/"+args[2]+".d"));
    } catch (IOException e) {
      System.out.println("d file could not be created.");
    }
    try {
      inputFile = new FileInputStream(args[1]);
    } catch (FileNotFoundException e) {
      System.out.println("Input file not found.");
    }

    parser = new Lpt2dzfc(inputFile);

    try {
      if (args[0].equals("-t")) {
        parser.SimpleTree();
        LogKeeper.setup("lpt2dzfc.log");
        LogKeeper.record(root.dump("    "));
      } else if (args[0].equals("-p")) {
        mdd.print = true;
        parser.defList();
        System.out.println("OK.\n");
      } else if (args[0].equals("-s") || args[0].equals("-o")) {
        parser.defList();
        System.out.println("OK.\n");
      }
    } catch (Exception e) {
      System.out.println("Oops.");
      System.out.println(e.getMessage());
      e.printStackTrace();
    }
  }

  public static String[] concatString(String[] a, String s) {
    if (a == null) {
      a = new String[1];
      a[0] = s;
    } else {
      String[] b = new String[a.length + 1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = s;
      a = b;
    }
    return a;
  }

  static final public void SimpleTree() throws ParseException {
  int depth = 0;
  Token t,u;
  XNode n;
  XNode current = root;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case UP:
      case DEFINITION:
      case DEFNAME:
      case DEFBODY:
      case INFIXDEFBODY:
      case RELNDEF:
      case RELNDEFUNIT:
      case INFIXRELNDEF:
      case INFIXRELNDEFUNIT:
      case FUNCDEF:
      case FUNCDEFUNIT:
      case INFIXFUNCDEF:
      case INFIXFUNCDEFUNIT:
      case PRECEDENCE:
      case TERM:
      case BTERM:
      case ATERM:
      case VARSEQ:
      case COMPOSITE:
      case SET:
      case TUPLE:
      case UNIQUE:
      case LAMBDA:
      case EVALUATION:
      case INFIXFUNC:
      case INFIXREL:
      case TERMSEQ:
      case FORMULA:
      case LC:
      case BFORMULA:
      case TERMFORMULA:
      case RELATION:
      case NEGATION:
      case ONETRUE:
      case FORMULASEQ:
      case FORALL:
      case EXISTS:
      case EXISTSUNIQUE:
      case VAR:
      case FSTR:
      case RSTR:
      case NUMERAL:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DEFINITION:
      case DEFNAME:
      case DEFBODY:
      case INFIXDEFBODY:
      case RELNDEF:
      case RELNDEFUNIT:
      case INFIXRELNDEF:
      case INFIXRELNDEFUNIT:
      case FUNCDEF:
      case FUNCDEFUNIT:
      case INFIXFUNCDEF:
      case INFIXFUNCDEFUNIT:
      case PRECEDENCE:
      case TERM:
      case BTERM:
      case ATERM:
      case VARSEQ:
      case COMPOSITE:
      case SET:
      case TUPLE:
      case UNIQUE:
      case LAMBDA:
      case EVALUATION:
      case INFIXFUNC:
      case INFIXREL:
      case TERMSEQ:
      case FORMULA:
      case LC:
      case BFORMULA:
      case TERMFORMULA:
      case RELATION:
      case NEGATION:
      case ONETRUE:
      case FORMULASEQ:
      case FORALL:
      case EXISTS:
      case EXISTSUNIQUE:
      case VAR:
      case FSTR:
      case RSTR:
      case NUMERAL:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DEFINITION:
          t = jj_consume_token(DEFINITION);
          break;
        case DEFNAME:
          t = jj_consume_token(DEFNAME);
          break;
        case DEFBODY:
          t = jj_consume_token(DEFBODY);
          break;
        case INFIXDEFBODY:
          t = jj_consume_token(INFIXDEFBODY);
          break;
        case RELNDEF:
          t = jj_consume_token(RELNDEF);
          break;
        case RELNDEFUNIT:
          t = jj_consume_token(RELNDEFUNIT);
          break;
        case INFIXRELNDEF:
          t = jj_consume_token(INFIXRELNDEF);
          break;
        case INFIXRELNDEFUNIT:
          t = jj_consume_token(INFIXRELNDEFUNIT);
          break;
        case FUNCDEF:
          t = jj_consume_token(FUNCDEF);
          break;
        case FUNCDEFUNIT:
          t = jj_consume_token(FUNCDEFUNIT);
          break;
        case INFIXFUNCDEF:
          t = jj_consume_token(INFIXFUNCDEF);
          break;
        case INFIXFUNCDEFUNIT:
          t = jj_consume_token(INFIXFUNCDEFUNIT);
          break;
        case PRECEDENCE:
          t = jj_consume_token(PRECEDENCE);
          break;
        case TERM:
          t = jj_consume_token(TERM);
          break;
        case BTERM:
          t = jj_consume_token(BTERM);
          break;
        case ATERM:
          t = jj_consume_token(ATERM);
          break;
        case VARSEQ:
          t = jj_consume_token(VARSEQ);
          break;
        case COMPOSITE:
          t = jj_consume_token(COMPOSITE);
          break;
        case SET:
          t = jj_consume_token(SET);
          break;
        case TUPLE:
          t = jj_consume_token(TUPLE);
          break;
        case UNIQUE:
          t = jj_consume_token(UNIQUE);
          break;
        case LAMBDA:
          t = jj_consume_token(LAMBDA);
          break;
        case EVALUATION:
          t = jj_consume_token(EVALUATION);
          break;
        case INFIXFUNC:
          t = jj_consume_token(INFIXFUNC);
          break;
        case INFIXREL:
          t = jj_consume_token(INFIXREL);
          break;
        case TERMSEQ:
          t = jj_consume_token(TERMSEQ);
          break;
        case FORMULA:
          t = jj_consume_token(FORMULA);
          break;
        case LC:
          t = jj_consume_token(LC);
          break;
        case BFORMULA:
          t = jj_consume_token(BFORMULA);
          break;
        case TERMFORMULA:
          t = jj_consume_token(TERMFORMULA);
          break;
        case RELATION:
          t = jj_consume_token(RELATION);
          break;
        case NEGATION:
          t = jj_consume_token(NEGATION);
          break;
        case ONETRUE:
          t = jj_consume_token(ONETRUE);
          break;
        case FORMULASEQ:
          t = jj_consume_token(FORMULASEQ);
          break;
        case FORALL:
          t = jj_consume_token(FORALL);
          break;
        case EXISTS:
          t = jj_consume_token(EXISTS);
          break;
        case EXISTSUNIQUE:
          t = jj_consume_token(EXISTSUNIQUE);
          break;
        case VAR:
          t = jj_consume_token(VAR);
          break;
        case FSTR:
          t = jj_consume_token(FSTR);
          break;
        case RSTR:
          t = jj_consume_token(RSTR);
          break;
        case NUMERAL:
          t = jj_consume_token(NUMERAL);
          break;
        default:
          jj_la1[1] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
           n = new XNode(t.image, current);
           current.addChild(n);
           current = n;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TXT:
          jj_consume_token(TXT);
          u = jj_consume_token(WORD);
                      current.addChild("text", u.image);
          break;
        default:
          jj_la1[2] = jj_gen;
          ;
        }
        break;
      case UP:
        jj_consume_token(UP);
           current = current.parent;
        label_2:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case WORD:
            ;
            break;
          default:
            jj_la1[3] = jj_gen;
            break label_2;
          }
          u = jj_consume_token(WORD);
                current.addChild("text", u.image);
        }
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(0);
  }

// ------------------------------------------------------
  static final public void defList() throws ParseException, IOException {
  FormulaBuilder tool = new FormulaBuilder();
  Definition d;
  String L;
  boolean first = true;
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DEFINITION:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_3;
      }
      d = definition();
     L = "\\begin{verbatim}\n\\end{verbatim}";
     L += "\n\n\\medskip\n" + tool.lineWrap(input,80);
     L += "\n\n\\bigskip\n" + d.body.buildLaTeX();
     //Alternate 1:
     L += "\n\n\\bigskip\n\\hrule\n\n\\bigskip\n";
     LaTeXoutputFile.write(L.getBytes());
     //Alternate 2:
     //if (first) {
     //  LaTeXoutputFile.write(L.getBytes());
     //  first = false;
     //} else {
     //  L = "\n\n\\bigskip\n\\hrule\n\n\\bigskip\n" + L;
     //  LaTeXoutputFile.write(L.getBytes());
     //}
     mdd.recordDef(d.name,d.body.dfd,d.body);
     eFileOutput += "\n";
     //eFile.write(eFileOutput.getBytes());
     eFileOutput = null;
    }
    jj_consume_token(0);
  }

// ------------------------------------------------------
  static final public Definition definition() throws ParseException, IOException {
  Definition definition = new Definition();
  String name;
  Body body;
    jj_consume_token(DEFINITION);
   input = "\\noindent DEFINITION ";
    name = defname();
    definition.name = name;
    System.out.println("Parsing definition: "+name+".");
   input += name + ": ";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DEFBODY:
      body = defbody();
                      definition.body = body;
      break;
    case INFIXDEFBODY:
      body = infixdefbody();
                           definition.body = body;
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    String v = "";
    if (body.arity.equals("infix")) {
      v = "Infix";
    } else {
      v = new String(body.arity) + "-ary";
    }
    String u = body.dfd + ":" + body.arity + "\n";
    dFile.write(u.getBytes());
    {if (true) return definition;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String defname() throws ParseException {
  Token t;
    jj_consume_token(DEFNAME);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public Body defbody() throws ParseException {
  Body body = new Body();
  FormulaBuilder[] data;
  String n, d;
    jj_consume_token(DEFBODY);
    n = numeral();
                 body.arity = n;
   input += "-ary ";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
     input+="relation $\\mathop{\\mathtt{";
      d = rstr();
     input +="}}$.";
      data = relndef();
     body.dfd = d; body.data = data; body.type = "relation";
      break;
    case FSTR:
     input+="function $\\mathop{\\mathtt{";
      d = fstr();
     input +="}}$.";
      data = funcdef();
     body.dfd = d; body.data = data; body.type = "function";
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return body;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public Body infixdefbody() throws ParseException {
  Body body = new Body();
  FormulaBuilder[] data;
  String d;
    jj_consume_token(INFIXDEFBODY);
   body.arity = "infix";
   input += "Infix ";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
     input+="relation $\\mathop{\\mathtt{";
      d = rstr();
     input +="}}$.";
      data = infixrelndef();
     body.dfd = d; body.data = data; body.type = "relation";
      break;
    case FSTR:
     input+="function $\\mathop{\\mathtt{";
      d = fstr();
     input +="}}$.";
      data = infixfuncdef();
     body.dfd = d; body.data = data; body.type = "function";
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return body;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] relndef() throws ParseException {
  Relndef relndef = new Relndef();
  FormulaBuilder[] r;
  FormulaBuilder f;
    jj_consume_token(RELNDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RELNDEFUNIT:
     input+= " ";
      r = relndefunit();
                       relndef.simple = r;
     input += ".";
      break;
    case FORMULA:
      label_4:
      while (true) {
      input += " If $";
        f = formula();
      input += "$ then ";
        r = relndefunit();
      relndef.addForm(f); relndef.addUnit(r);
      input += ".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_4;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RELNDEFUNIT:
      input += " Otherwise ";
        r = relndefunit();
                                                  relndef.otherwise = r;
      input += ".";
        break;
      default:
        jj_la1[10] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[11] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return relndef.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] relndefunit() throws ParseException {
  FormulaBuilder[] f = new FormulaBuilder[2];
  DefinedConcept defconcept = new DefinedConcept("relation");
  String r;
  String[] a;
    jj_consume_token(RELNDEFUNIT);
   input+="$\\mathop{\\mathtt{";
    r = rstr();
              defconcept.concept = r;
   input +="}}[";
    a = varseq();
   defconcept.wrapVars(a); defconcept.dfd(true); f[0] = defconcept.output();
   input += "] \\leftrightarrow ";
    f[1] = formula();
   input += "$";
    jj_consume_token(UP);
    if (eFileOutput==null) {
      eFileOutput = r + "[";
      for (int i = 0; i < a.length; i++) {
        eFileOutput += a[i] + (i==a.length-1?"":",");
      }
      eFileOutput += "]";
    }
    {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] infixrelndef() throws ParseException {
  Relndef relndef = new Relndef();
  FormulaBuilder[] r;
  FormulaBuilder f;
    jj_consume_token(INFIXRELNDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXRELNDEFUNIT:
     input+= " ";
      r = infixrelndefunit();
                            relndef.simple = r;
     input += ".";
      break;
    case FORMULA:
      label_5:
      while (true) {
      input += " If $";
        f = formula();
      input += "$ then ";
        r = infixrelndefunit();
      relndef.addForm(f); relndef.addUnit(r);
      input += ".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[12] = jj_gen;
          break label_5;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXRELNDEFUNIT:
      input += " Otherwise ";
        r = infixrelndefunit();
                                                       relndef.otherwise = r;
      input += ".";
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    {if (true) return relndef.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] infixrelndefunit() throws ParseException {
  FormulaBuilder[] f = new FormulaBuilder[2];
  DefinedConcept defconcept = new DefinedConcept("relation");
  String r;
  String[] a = new String[2];
    jj_consume_token(INFIXRELNDEFUNIT);
   input+="$";
    a[0] = var();
   input+=" \\mathop{\\mathtt{";
    r = rstr();
   input+="}} ";
    a[1] = var();
   input+=" \\leftrightarrow ";
    f[1] = formula();
   input += "$";
    jj_consume_token(UP);
    defconcept.concept = r;
    defconcept.arity = "infix";
    defconcept.wrapVars(a);
    defconcept.dfd(true);
    f[0] = defconcept.output();
    if (eFileOutput==null) {
      eFileOutput = r+"["+a[0]+","+a[1]+"]";
    }
    {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] funcdef() throws ParseException {
  Funcdef funcdef = new Funcdef();
  FormulaBuilder[] u;
  FormulaBuilder c;
    jj_consume_token(FUNCDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FUNCDEFUNIT:
     input+= " ";
      u = funcdefunit();
                       funcdef.simple = u;
     input += ".";
      break;
    case FORMULA:
      label_6:
      while (true) {
      input += " If $";
        c = formula();
      input += "$ then ";
        u = funcdefunit();
      funcdef.addCond(c); funcdef.addUnit(u);
      input += ".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[15] = jj_gen;
          break label_6;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FUNCDEFUNIT:
      input += " Otherwise ";
        u = funcdefunit();
                                                  funcdef.otherwise = u;
      input += ".";
        break;
      default:
        jj_la1[16] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[17] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    {if (true) return funcdef.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] funcdefunit() throws ParseException {
  FormulaBuilder[] f = new FormulaBuilder[2];
  f[1] = null;
  DefinedConcept defconcept;
    jj_consume_token(FUNCDEFUNIT);
   input += "$";
    defconcept = composite();
                            defconcept.dfd(true); f[0] = defconcept.output();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TERM:
    input += " \\simeq ";
      f[1] = term();
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
    if (f[1]==null) {input += "\\mathord{\\uparrow}";}
    {input += "$";}
    jj_consume_token(UP);
    if (eFileOutput==null) {
      eFileOutput = defconcept.concept;
      int z = defconcept.args.length;
      if (z>0) {
        eFileOutput += "(";
        for (int i = 0; i < z; i++) {
          eFileOutput += defconcept.args[i].toStringNaked();
          eFileOutput += (i==z-1?"":",");
        }
        eFileOutput += ")";
      }
    }
    {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] infixfuncdef() throws ParseException {
  Funcdef funcdef = new Funcdef();
  FormulaBuilder[] u;
  FormulaBuilder c;
  String p;
    jj_consume_token(INFIXFUNCDEF);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXFUNCDEFUNIT:
     input+= " ";
      u = infixfuncdefunit();
     input += ". Precedence ";
      p = precedence();
     funcdef.simple = u; funcdef.prec = p;
     input += ".";
      break;
    case FORMULA:
      label_7:
      while (true) {
      input += " If $";
        c = formula();
      input += "$ then ";
        u = infixfuncdefunit();
      funcdef.addCond(c); funcdef.addUnit(u);
      input += ".";
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORMULA:
          ;
          break;
        default:
          jj_la1[19] = jj_gen;
          break label_7;
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXFUNCDEFUNIT:
      input += " Otherwise ";
        u = infixfuncdefunit();
                                                       funcdef.otherwise = u;
      input += ".";
        break;
      default:
        jj_la1[20] = jj_gen;
        ;
      }
     input += " Precedence ";
      p = precedence();
                      funcdef.prec = p;
     input += ".";
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    {if (true) return funcdef.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] infixfuncdefunit() throws ParseException {
  FormulaBuilder[] f = new FormulaBuilder[2];
  f[1] = null;
  DefinedConcept defconcept = new DefinedConcept("function");
  String x;
  String[] a = new String[2];
    jj_consume_token(INFIXFUNCDEFUNIT);
   input+="$";
    a[0] = var();
   input+=" \\mathop{\\mathtt{";
    x = fstr();
   input+="}} ";
    a[1] = var();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TERM:
    input+=" \\simeq ";
      f[1] = term();
      break;
    default:
      jj_la1[22] = jj_gen;
      ;
    }
    if (f[1]==null) {input += "\\mathord{\\uparrow}";}
    {input += "$";}
    jj_consume_token(UP);
    defconcept.concept = x;
    defconcept.arity = "infix";
    defconcept.wrapVars(a);
    defconcept.dfd(true);
    f[0] = defconcept.output();
    if (eFileOutput==null) {
      eFileOutput = x+"("+a[0]+","+a[1]+")";
    }
    {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String precedence() throws ParseException {
  Token t;
    jj_consume_token(PRECEDENCE);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
   input += t.image;
    jj_consume_token(UP);
   {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder term() throws ParseException {
  Term term = new Term();
  FormulaBuilder f,g;
  Infixfunc m;
    jj_consume_token(TERM);
    f = bterm();
               term.maybesimple = f;
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXFUNC:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_8;
      }
     input+= " ";
      m = infixfunc();
                     term.addIF(m);
     input+= " ";
      g = bterm();
                 term.addBT(g);
    }
    jj_consume_token(UP);
   {if (true) return term.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder bterm() throws ParseException {
  Bterm bterm = new Bterm();
  FormulaBuilder f;
  FormulaBuilder[] a;
    jj_consume_token(BTERM);
    f = aterm();
               bterm.aterm = f;
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EVALUATION:
        ;
        break;
      default:
        jj_la1[24] = jj_gen;
        break label_9;
      }
      a = evaluation();
                     bterm.addEval(a);
    }
    jj_consume_token(UP);
   {if (true) return bterm.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder aterm() throws ParseException {
  Aterm aterm = new Aterm();
  DefinedConcept defconcept;
  FormulaBuilder f = null;
  String s;
    jj_consume_token(ATERM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      s = var();
               aterm.var = s; f = aterm.output();
      break;
    case NUMERAL:
      s = numeral();
                   aterm.numeral = s; f = aterm.output();
      break;
    case COMPOSITE:
      defconcept = composite();
                              defconcept.dfd(false); f = defconcept.output();
      break;
    case TERM:
     input+= "(";
      f = term();
                               aterm.term = f; f = aterm.output();
                                                                     input+= ")";
      break;
    case SET:
      f = set();
      break;
    case TUPLE:
      f = tuple();
      break;
    case UNIQUE:
      f = unique();
      break;
    case LAMBDA:
      f = lambda();
      break;
    default:
      jj_la1[25] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String[] varseq() throws ParseException {
  String[] a = new String[1];
  String s;
    jj_consume_token(VARSEQ);
    s = var();
             a[0] = s;
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VAR:
        ;
        break;
      default:
        jj_la1[26] = jj_gen;
        break label_10;
      }
     input+= ",";
      s = var();
               a = concatString(a,s);
    }
    jj_consume_token(UP);
   {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public DefinedConcept composite() throws ParseException {
  DefinedConcept defconcept = new DefinedConcept("function");
  defconcept.mdd = mdd;
  String s;
  FormulaBuilder[] t;
    jj_consume_token(COMPOSITE);
   input+="\\mathop{\\mathtt{";
    s = fstr();
              defconcept.concept = s;
   input+="}}";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EVALUATION:
      t = evaluation();
                     defconcept.args = t;
      break;
    default:
      jj_la1[27] = jj_gen;
      ;
    }
    jj_consume_token(UP);
   {if (true) return defconcept;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder set() throws ParseException {
  Set set = new Set();
  FormulaBuilder t,f;
  FormulaBuilder[] a = new FormulaBuilder[0];
  FormulaBuilder[] b;
  Infixrel m;
  String[] ss;
    jj_consume_token(SET);
   input+= "\\lbrace ";
    t = term();
              set.term = t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
    case TERMSEQ:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TERMSEQ:
      input+=",";
        a = termseq();
        break;
      default:
        jj_la1[28] = jj_gen;
        ;
      }
      jj_consume_token(TXT);
                                          set.merelist = a;
     input+=" \\rbrace ";
      break;
    case INFIXREL:
    case FORMULA:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
      input+=" ";
        m = infixrel();
                     input+=" ";
        b = termseq();
      set.precondrel = m; set.precondterms = b;
        break;
      default:
        jj_la1[29] = jj_gen;
        ;
      }
     input+=" : ";
      f = formula();
                   set.suchthat = f;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VARSEQ:
      input+=", ";
        ss = varseq();
                    set.fixed = ss;
                                      input+=" fixed";
        break;
      default:
        jj_la1[30] = jj_gen;
        ;
      }
     input+=" \\rbrace ";
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return set.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder tuple() throws ParseException {
  FormulaBuilder[] a;
  Tupler tupler = new Tupler();
    jj_consume_token(TUPLE);
   input+="\\seq{";
    a = termseq();
   input+="}";
    jj_consume_token(UP);
   {if (true) return tupler.tuple(a);}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder unique() throws ParseException {
  Unique unique = new Unique();
  FormulaBuilder t,f;
  FormulaBuilder[] b;
  Infixrel m;
  String[] ss;
    jj_consume_token(UNIQUE);
   input+="(! ";
    t = term();
              unique.term = t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXREL:
    input+=" ";
      m = infixrel();
                   input+=" ";
      b = termseq();
    unique.precondrel = m; unique.precondterms = b;
      break;
    default:
      jj_la1[32] = jj_gen;
      ;
    }
   input+=")";
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BFORMULA:
      f = bformula();
                    unique.suchthat = f;
      break;
    case FORMULA:
     input+="(";
      f = formula();
     input+=", ";
      ss = varseq();
                   unique.suchthat = f; unique.fixed = ss;
     input+=" fixed)";
      break;
    default:
      jj_la1[33] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return unique.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder lambda() throws ParseException {
  Lambda lambda = new Lambda();
  String[] vv;
  FormulaBuilder t,phi;
  Infixrel alpha;
  FormulaBuilder[] s;
    jj_consume_token(LAMBDA);
   input+="(\\lambda ";
    vv = varseq();
                 lambda.vars = vv;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIXREL:
    input+=" ";
      alpha = infixrel();
                                     input+=" ";
      s = termseq();
    lambda.onecondRel = alpha; lambda.onecondTerms = s;
      break;
    default:
      jj_la1[34] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FORMULA:
    input+=" : ";
      phi = formula();
                                    lambda.twocond = phi;
      break;
    default:
      jj_la1[35] = jj_gen;
      ;
    }
   input+=")";
    t = bterm();
               lambda.term = t;
    jj_consume_token(UP);
   {if (true) return lambda.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] evaluation() throws ParseException {
  FormulaBuilder[] fba;
    jj_consume_token(EVALUATION);
   input+="(";
    fba = termseq();
   input+=")";
    jj_consume_token(UP);
   {if (true) return fba;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public Infixfunc infixfunc() throws ParseException {
  Infixfunc infixfunc = new Infixfunc();
  infixfunc.mdd = mdd;
  String s;
  FormulaBuilder fb;
    jj_consume_token(INFIXFUNC);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FSTR:
      s = fstr();
                 infixfunc.defined = s;
      break;
    case TERM:
      input+="\\infixfn{";
      fb = term();
                                         infixfunc.term = fb;
                                                                input+="}";
      break;
    default:
      jj_la1[36] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return infixfunc;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public Infixrel infixrel() throws ParseException {
  Infixrel infixrel = new Infixrel();
  infixrel.mdd = mdd;
  Token t;
  String s;
  FormulaBuilder fb;
    jj_consume_token(INFIXREL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case RSTR:
      input+="\\mathop{\\mathtt{";
      s = rstr();
                 infixrel.defined = s;
      input+="}}";
      break;
    case TXT:
      jj_consume_token(TXT);
      t = jj_consume_token(WORD);
                       infixrel.standard = t.image;
                                                      input+=t.image;
      break;
    case TERM:
      input+="\\infixrel{";
      fb = term();
                                          infixrel.term = fb;
                                                                input+="}";
      break;
    default:
      jj_la1[37] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return infixrel;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] termseq() throws ParseException {
  FormulaBuilder[] t = new FormulaBuilder[1];
  FormulaBuilder[] s;
  FormulaBuilder f;
    jj_consume_token(TERMSEQ);
    f = term();
              t[0] = f;
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TERM:
        ;
        break;
      default:
        jj_la1[38] = jj_gen;
        break label_11;
      }
     input+=",";
      f = term();
      s = new FormulaBuilder[t.length+1];
      System.arraycopy(t,0,s,0,t.length);
      s[t.length] = f;
      t = s;
    }
    jj_consume_token(UP);
   {if (true) return t;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder formula() throws ParseException {
  FormulaBuilder fba = new FormulaBuilder();
  FormulaBuilder fbb;
  String s;
    jj_consume_token(FORMULA);
    fbb = bformula();
                    fba.append(fbb);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LC:
        ;
        break;
      default:
        jj_la1[39] = jj_gen;
        break label_12;
      }
     input+=" ";
      s = lc();
     input+=" ";
      fbb = bformula();
      fba.addText(" " + s + " ");
      fba.append(fbb);
    }
    jj_consume_token(UP);
   {if (true) return fba;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String lc() throws ParseException {
  Token t;
    jj_consume_token(LC);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
                    input+=t.image;
    jj_consume_token(UP);
   {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder bformula() throws ParseException {
  FormulaBuilder fba = new FormulaBuilder();
  DefinedConcept defconcept;
  Token t;
  String s;
    jj_consume_token(BFORMULA);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      t = jj_consume_token(WORD);
                       s = t.image; fba.addText(s);
                                                      input+=t.image;
      break;
    case TERMFORMULA:
      fba = termformula();
      break;
    case RELATION:
      defconcept = relation();
                              defconcept.dfd(false); fba = defconcept.output();
      break;
    case FORMULA:
      input+="(";
      fba = formula();
                                    input+=")";
      break;
    case NEGATION:
      fba = negation();
      break;
    case ONETRUE:
      fba = onetrue();
      break;
    case FORALL:
      fba = forall();
      break;
    case EXISTS:
      fba = exists();
      break;
    case EXISTSUNIQUE:
      fba = existsunique();
      break;
    default:
      jj_la1[40] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return fba;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder termformula() throws ParseException {
  Termformula termformula = new Termformula();
  FormulaBuilder fb;
  FormulaBuilder[] fba;
  Infixrel infixrel;
  Token t;
  String s;
    jj_consume_token(TERMFORMULA);
    fb = term();
               termformula.initial = fb;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WORD:
        t = jj_consume_token(WORD);
                        termformula.definedness(t.image);
             input+="\\mathord{" + t.image + "}";
        break;
      case TERMSEQ:
              input+="[";
        fba = termseq();
                                            termformula.maybepred = fba;
                                                                           input+="]";
        break;
      default:
        jj_la1[41] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case TERMSEQ:
      input+=",";
      fba = termseq();
                                    termformula.maybepred = fba;
      input+=" ";
      infixrel = infixrel();
      input+=" ";
      fba = termseq();
         termformula.nope = infixrel;
         termformula.mandatory = fba;
         //Diagnostic:
         if (termformula.mandatory==null) {
           System.out.println("<Lpt2dzfc.jj:913>WTF");
         }
         System.out.println("<Lpt2dzfc.jj:915>"+termformula.mandatory[0].toStringNaked());
         //

      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INFIXREL:
          ;
          break;
        default:
          jj_la1[42] = jj_gen;
          break label_13;
        }
       input+=" ";
        infixrel = infixrel();
       input+=" ";
        fba = termseq();
                                     termformula.further(infixrel,fba);
      }
      break;
    case INFIXREL:
      input+=" ";
      infixrel = infixrel();
      input+=" ";
      fba = termseq();
                                    termformula.nope = infixrel; termformula.mandatory = fba;
      label_14:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INFIXREL:
          ;
          break;
        default:
          jj_la1[43] = jj_gen;
          break label_14;
        }
       input+=" ";
        infixrel = infixrel();
       input+=" ";
        fba = termseq();
                                     termformula.further(infixrel,fba);
      }
      break;
    default:
      jj_la1[44] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
    //Diagnostic:
    System.out.println("<Lpt2dzfc.jj:929>"+termformula.initial.toStringNaked());
    //
    {if (true) return termformula.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public DefinedConcept relation() throws ParseException {
  DefinedConcept defconcept = new DefinedConcept("relation");
  defconcept.mdd = mdd;
  String s = null;
  FormulaBuilder[] t;
    jj_consume_token(RELATION);
   input+="\\mathop{\\mathtt{";
    s = rstr();
              defconcept.concept = s;
   input+="}}";
   input+="[";
    t = termseq();
                 defconcept.args = t;
   input+="]";
    jj_consume_token(UP);
   {if (true) return defconcept;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder negation() throws ParseException {
  FormulaBuilder f,g;
    jj_consume_token(NEGATION);
   input+="\\neg ";
    g = bformula();
    jj_consume_token(UP);
    f = new FormulaBuilder();
    f.addText("\\neg(");
    f.append(g);
    f.addText(")");
    {if (true) return f;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder onetrue() throws ParseException {
  Onetrue onetrue = new Onetrue();
  FormulaBuilder[] a;
    jj_consume_token(ONETRUE);
   input+="![";
    a = formulaseq();
   input+="]";
    jj_consume_token(UP);
   {if (true) return onetrue.output(a);}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder[] formulaseq() throws ParseException {
  FormulaBuilder f;
  FormulaBuilder[] a = new FormulaBuilder[1];
    jj_consume_token(FORMULASEQ);
    a[0] = formula();
    label_15:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FORMULA:
        ;
        break;
      default:
        jj_la1[45] = jj_gen;
        break label_15;
      }
     input+=",";
      f = formula();
      FormulaBuilder[] b = new FormulaBuilder[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = f;
      a = b;
    }
    jj_consume_token(UP);
   {if (true) return a;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder forall() throws ParseException {
  Quant quant = new Quant("forall");
  FormulaBuilder[] t,s;
  FormulaBuilder rho, phi, psi;
  Infixrel alpha;
  String[] v;
    jj_consume_token(FORALL);
   input+="(\\forall ";
    t = termseq();
                 quant.boundterms = t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
           input+=" : ";
      rho = formula();
                                           input+=")";
      phi = bformula();
     quant.suchthat = rho; quant.formula = phi;
      break;
    case INFIXREL:
    case FORMULA:
    case BFORMULA:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
      input+=" ";
        alpha = infixrel();
                                       input+=" ";
        s = termseq();
      quant.ifcRel = alpha; quant.ifcTerms = s;
        break;
      default:
        jj_la1[46] = jj_gen;
        ;
      }
     input+=")";
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula();
                        quant.formula = phi;
        break;
      case FORMULA:
       input+="(";
        psi = formula();
       input+=", ";
        v = varseq();
                                   quant.formula = psi; quant.fixed = v;
       input+=" fixed)";
        break;
      default:
        jj_la1[47] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return quant.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder exists() throws ParseException {
  Quant quant = new Quant("exists");
  FormulaBuilder[] t,s;
  FormulaBuilder rho, phi, psi;
  Infixrel alpha;
  String[] v;
    jj_consume_token(EXISTS);
   input+="(\\exists ";
    t = termseq();
                 quant.boundterms = t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
           input+=" : ";
      rho = formula();
                                           input+=")";
      phi = bformula();
     quant.suchthat = rho; quant.formula = phi;
      break;
    case INFIXREL:
    case FORMULA:
    case BFORMULA:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
      input+=" ";
        alpha = infixrel();
                                       input+=" ";
        s = termseq();
      quant.ifcRel = alpha; quant.ifcTerms = s;
        break;
      default:
        jj_la1[49] = jj_gen;
        ;
      }
     input+=")";
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula();
                        quant.formula = phi;
        break;
      case FORMULA:
       input+="(";
        psi = formula();
       input+=", ";
        v = varseq();
                                   quant.formula = psi; quant.fixed = v;
       input+=" fixed)";
        break;
      default:
        jj_la1[50] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[51] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return quant.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public FormulaBuilder existsunique() throws ParseException {
  Quant quant = new Quant("existsUnique");
  FormulaBuilder[] t,s;
  FormulaBuilder rho, phi, psi;
  Infixrel alpha;
  String[] v;
    jj_consume_token(EXISTSUNIQUE);
   input+="(\\exists ! ";
    t = termseq();
                 quant.boundterms = t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TXT:
      jj_consume_token(TXT);
           input+=" : ";
      rho = formula();
                                           input+=")";
      phi = bformula();
     quant.suchthat = rho; quant.formula = phi;
      break;
    case INFIXREL:
    case FORMULA:
    case BFORMULA:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIXREL:
      input+=" ";
        alpha = infixrel();
                                       input+=" ";
        s = termseq();
      quant.ifcRel = alpha; quant.ifcTerms = s;
        break;
      default:
        jj_la1[52] = jj_gen;
        ;
      }
     input+=")";
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BFORMULA:
        phi = bformula();
                        quant.formula = phi;
        break;
      case FORMULA:
       input+="(";
        psi = formula();
       input+=", ";
        v = varseq();
                                   quant.formula = psi; quant.fixed = v;
       input+=" fixed)";
        break;
      default:
        jj_la1[53] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[54] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(UP);
   {if (true) return quant.output();}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String var() throws ParseException {
  Token t;
    jj_consume_token(VAR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
                    input+=t.image;
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String fstr() throws ParseException {
  Token t;
    jj_consume_token(FSTR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
                    input+=t.image;
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String rstr() throws ParseException {
  Token t;
    jj_consume_token(RSTR);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
                    input+=t.image;
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

// ------------------------------------------------------
  static final public String numeral() throws ParseException {
  Token t;
    jj_consume_token(NUMERAL);
    jj_consume_token(TXT);
    t = jj_consume_token(WORD);
                    input+=t.image;
    jj_consume_token(UP);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  static private boolean jj_initialized_once = false;
  static public Lpt2dzfcTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[55];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0xffffffc0,0xffffff80,0x20,0x0,0xffffffc0,0x80,0x600,0x0,0x0,0x0,0x1000,0x1000,0x0,0x4000,0x4000,0x0,0x10000,0x10000,0x100000,0x0,0x40000,0x40000,0x100000,0x40000000,0x20000000,0x1f100000,0x0,0x20000000,0x0,0x80000000,0x800000,0x80000020,0x80000000,0x0,0x80000000,0x0,0x100000,0x100020,0x100000,0x0,0x20,0x0,0x80000000,0x80000000,0x80000020,0x0,0x80000000,0x0,0x80000020,0x80000000,0x0,0x80000020,0x80000000,0x0,0x80000020,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0xffff,0xffff,0x0,0x10000,0xffff,0x0,0x0,0x6000,0x6000,0x2,0x0,0x2,0x2,0x0,0x2,0x2,0x0,0x2,0x0,0x2,0x0,0x2,0x0,0x0,0x0,0x9000,0x1000,0x0,0x1,0x0,0x0,0x3,0x0,0xa,0x0,0x2,0x2000,0x4000,0x0,0x4,0xef2,0x10001,0x0,0x0,0x1,0x2,0x0,0xa,0xa,0x0,0xa,0xa,0x0,0xa,0xa,};
   }

  public Lpt2dzfc(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new Lpt2dzfcTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  public Lpt2dzfc(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new Lpt2dzfcTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  public Lpt2dzfc(Lpt2dzfcTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  public void ReInit(Lpt2dzfcTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 55; i++) jj_la1[i] = -1;
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[49];
    for (int i = 0; i < 49; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 55; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 49; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

}
