package lpt2dzfc;

public class Relndef{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public FormulaBuilder[] simple = null;
  private FormulaBuilder[] conditions = null;
  private FormulaBuilder[][] units = null;
  public FormulaBuilder[] otherwise = null;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Relndef() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder[] output() {
    FormulaBuilder[] D = new FormulaBuilder[3];
    if (simple!=null) {
      //Align free variables:
      simple[1].prefixVars(simple[0]);
      //Definiens:
      D[2] = simple[1];
      //Definiendum:
      D[1] = simple[0];
      //Def:
      FormulaBuilder def = new FormulaBuilder();
      def.append(simple[0]);
      def.addText(" \\rightleftarrow ");
      def.append(simple[1]);
      D[0] = def;
    } else {
      //Align free variables:
      for (int i = 0; i < units.length; i++) {
        units[i][1].prefixVars(units[i][0]);
      }
      if (otherwise!=null) {otherwise[1].prefixVars(otherwise[0]);}
      //Definiens:
      D[2] = new FormulaBuilder();
      for (int i = 0; i < conditions.length; i++) {
        D[2].addText("(");
        D[2].append(conditions[i]);
        D[2].addText(" \\wedge ");
        D[2].append(units[i][1]);
        D[2].addText(")");
        if (i!=conditions.length-1) {D[2].addText(" \\vee ");}
      }
      if (otherwise!=null) {
        D[2].addText(" \\vee (\\neg (");
        for (int i = 0; i < conditions.length; i++) {
          D[2].append(conditions[i]);
          if (i!=conditions.length-1) {D[2].addText(" \\vee ");}
        }
        D[2].addText(") \\wedge ");
        D[2].append(otherwise[1]);
        D[2].addText(")");
      }
      //Definiendum:
      D[1] = units[0][0];
      //Def:
      FormulaBuilder def = new FormulaBuilder();
      def.append(D[1]);
      def.addText(" \\rightleftarrow ");
      def.append(D[2]);
      D[0] = def;
    }
    return D;
  }
  
  public void addForm(FormulaBuilder f) {
    if (conditions==null) {
      conditions = new FormulaBuilder[1];
      conditions[0] = f;
    } else {
      FormulaBuilder[] a = new FormulaBuilder[conditions.length+1];
      System.arraycopy(conditions,0,a,0,conditions.length);
      a[conditions.length] = f;
      conditions = a;
    }
  }
  
  public void addUnit(FormulaBuilder[] r) {
    if (units==null) {
      units = new FormulaBuilder[1][];
      units[0] = r;
    } else {
      FormulaBuilder[][] a = new FormulaBuilder[units.length+1][];
      System.arraycopy(units,0,a,0,units.length);
      a[units.length] = r;
      units = a;
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 