package lpt2dzfc;

public class XNode {
  
  public String type = "";
  public String text = "";
  public XNode parent;
  public XNode[] children;
  public int childnum = 0;
  public String[] data = null;
  public int datanum = 0;
  
  public XNode() {
  }
  
  public XNode(String type, String text) {
    this.type = type;
    this.text = text;
  }

  public XNode(String type, XNode par) {
    this.type = type;
    this.parent = par;
  }
  
  public int getChildnum() {
    return(childnum);
  }
  
  public void setParent(XNode par) {
    this.parent = par;
  }
  
  public void addData(String s) {
    if (datanum == 0) {
      data = new String[1];
    } else {
      String[] d = new String[datanum + 1];
      System.arraycopy(data, 0, d, 0, datanum);
      data = d;
    }
    data[datanum] = s;
    datanum++;
  }
  
  public void addChild(XNode n) {
    if (childnum == 0) {
      children = new XNode[1];
    } else {
      XNode[] c = new XNode[childnum + 1];
      System.arraycopy(children, 0, c, 0, childnum);
      children = c;      
    }
    children[childnum] = n;
    childnum++;
  }
  
  public void addChild(XNode[] n) {
    for (int i = 0; i < n.length; i++) {
      addChild(n[i]);
    }
  }
  
  public void addChild(String type, String text) {
    if (childnum == 0) {
      children = new XNode[1];
    } else {
      XNode[] c = new XNode[childnum + 1];
      System.arraycopy(children, 0, c, 0, childnum);
      children = c;      
    }
    children[childnum] = new XNode(type, text);
    childnum++;
  }
  
  public void addChild(String[] type, String[] text) {
    for (int i = 0; i < type.length; i++) {
      addChild(type[i], text[i]);
    }
  }
  
  public String dump(String indent) {
    String tree = ">" + type;
    if (text.length() != 0) { tree = tree + ":" + text; }
    if (data != null) {
      tree += "\n" + indent + " data: " + data[0];
      for (int i = 1; i < data.length; i++) {
        tree += ", " + data[i];
      }
    }
    for (int i = 0; i < childnum; i++) {
      tree = tree + "\r\n" + indent + children[i].dump(indent + "    ");
    }
    return(tree);
  }
  
}












