package util.quantifiers;

import util.scanner.*;

public class QCounter{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  String formula;
  Scanner scanner;
  int parenLevel, quantLevel, quantMax, quantMaxLoc;

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public QCounter(String s) {
    formula = "(" + s + ")";
    scanner = new Scanner(formula);
    String[] x = {"(", ")", "\\", " "};
    ScanningTool.flags = x;
    parenLevel = 0;
    quantLevel = 0;
    quantMax = 0;
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public int[] count() {
  /** ***************************************************************
   *  Returns an int[] of length two. In the first position is the
   *  maximum nested quantifier depth occurring in the formula, and in
   *  the second position is the location (in characters) at which the
   *  maximum depth first occurs.
   ****************************************************************** */
     explore(0);
     int[] z = new int[2];
     z[0] = quantMax;
     z[1] = quantMaxLoc;
     return z;
  }
  
  private void explore(int returnLevel) {
    String[] r;
     do {
       r = scanner.scan();
       parenCheck(r);
       if (r[1].equals("\\")) {
         r = scanner.scan();
         parenCheck(r);
         if (r[1].equals(" ")) {
           String c = r[0].substring(0,r[0].length()-1);
           if (c.equals("forall") || c.equals("exists")) {
             quantLevel++;
             if (quantLevel > quantMax) {
               quantMax = quantLevel; quantMaxLoc = scanner.pointer;
             }
             while (!r[1].equals(")")) {
               r = scanner.scan();
               parenCheck(r);
             }
             int a = parenLevel;
             int p = scanner.pointer;
             if (!formula.substring(p,p+1).equals("(")) {a--;}
             explore(a);
             quantLevel--;
           }
         }
       }
     } while (parenLevel > returnLevel);
  }
  
  private void parenCheck(String[] r) {
    if (r[1].equals("(")) {parenLevel++;}
    if (r[1].equals(")")) {parenLevel--;}
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 